//Variables globales
//FIXME: ¿es posible hacerlo de otra manera con JQuery? ¿En lugar de function(){} pueden utilizarse () => {}?
let total = 0;
let acertadas = 0;

function marcaAcierto(pregunta) {
  acertadas++;
  $(pregunta).addClass("respuesta-acertada");
}

function marcaError(pregunta) {
  $(pregunta).addClass("respuesta-erronea");
}

function reseteaEstado() {
  //TODO: borrar respuestas
  //Eliminamos cualquier estilo de acierto/error
  $("p.pregunta").each(
    function() {
      $(this).removeClass("respuesta-acertada");
      $(this).removeClass("respuesta-erronea");
    }
  );
}

//Cuando esté disponible el documento
$(function() {

/*** PREPARACIÓN DEL FORMULARIO ***/
/*********************************/
  $("#form-principal").accordion(
    {
      header: ".texto-pregunta",
      active: false,
      collapsible: true,
      heightStyle: "content"
    }
  );

  $(".lista-opciones input").checkboxradio();

  $("select").selectmenu();

  $("#dialogo-resultados").dialog({
    autoOpen: false,
    title: "Resulados",
    buttons: [
      {
        text: "OK",
        icon: "ui-icon-check",
        click: function() {
          $(this).dialog("close");
        }
      }
    ]

  });


/*** CORRECCIÓN DEL FORMULARIO ***/
/*********************************/
  reseteaEstado();

  //Definimos el evento click
  $("#boton-comprobar").on(
    "click",
    function() {
      //Reiniciamos los contadores
      total = 0;
      acertadas = 0;
      reseteaEstado();

      //Vamos a recorrer todos los párrafos de la clase pregunta
      $("p.pregunta").each(
        function() {
          let dataTest = $(this).data("test"); //Debe ser un objeto {valor, control {id, tipo, valor}}
          total = total + dataTest.valor;
          let tipoPregunta = dataTest.control.tipo;
          if (tipoPregunta == "texto") {
            let respuesta = $("#" + dataTest.control.id[0]).val();
            if (dataTest.control.valor.includes(respuesta.trim())) {
              //Acierto
              marcaAcierto(this);
            } else {
              marcaError(this);
            }

          } else if (tipoPregunta == "radio") {
            //Esto es demasiado "elegante"
            if ( ($("#" + dataTest.control.id[0] + ":checked")).length > 0 ) {
              //Acierto
              marcaAcierto(this);
            } else {
              marcaError(this);
            }

          } else if (tipoPregunta == "dropdown") {
            if ( $("#" + dataTest.control.id[0]).val() == dataTest.control.valor[0]) {
              //Acierto
              marcaAcierto(this);
            } else {
              marcaError(this);
            }

          } else if (tipoPregunta == "checkbox") {
            //...
            if ( $(dataTest.control.id.map((elemento) => "#" + elemento + ":checked").join()).length == dataTest.control.id.length &&
                  $(dataTest.control.idMal.map((elemento) => "#" + elemento + ":checked").join()).length == 0) {
              //Acierto
              marcaAcierto(this);
            } else {
              marcaError(this);
            }
          }
        }

      );
      //alert("Tienes " + acertadas + " respuestas acertadas de " + total + " preguntas");
      //Usamos el diálogo en su lugar
      //Primer cerramos todos los acordeones
      $("#form-principal").accordion("option","active",false);
      //Y ahora colocamos los datos
      $("#output-acertadas").val(acertadas);
      $("#output-preguntas").val(total);
      $("#dialogo-resultados").dialog("open");
    }

  );

});
